﻿Imports System.Drawing.Printing

Public Class Form1

    'il nostro Documento da Stampare
    Friend WithEvents DocumentoDaStampare As New PrintDocument

    'pulsante per la stampa diretta senza finestre di dialogo
    Private WithEvents btnStampa As New Button

    'pulsante per stampare attraverso la normale e consueta finestra di dialogo "STAMPA"
    Private WithEvents btnPrintDialog As New Button

    'pulsante per l'utilizzo dell'anteprima
    Private WithEvents btnPrintPreviewDialog As New Button

    'pulsante per impostare la pagina di stampa
    Private WithEvents btnPageSetupDialog As New Button

    'i nostri oggetti per la stampa:
    'finestra di dialogo "STAMPA"
    Private PrintDialog1 As New PrintDialog

    'finestra "ANTEPRIMA"
    Private PrintPreviewDialog1 As New PrintPreviewDialog

    'Fimestra "IMPOSTA PAGINA"
    Private PageSetupDialog1 As New PageSetupDialog

    'controllo "ANTEPRIMA" da usare nei controlli utente personalizzati
    Friend WithEvents PrintPreviewControl1 As New PrintPreviewControl

    Public Sub New()

        InitializeComponent()

        'impostiamo la nostra form
        With Me
            Size = New Size(500, 500)
            .Text = "Oggetti di Stampa"
        End With

        'impostiamo il pulsante per la stampa diretta
        With btnStampa
            .Size = New Size(125, 25)
            .Location = New Point(25, 25)
            .Text = "Stampa"
        End With

        'impostiamo il pulsante per la visualizzazione della finestra Stampa
        With btnPrintDialog
            .Size = New Size(125, 25)
            .Location = New Point(25, 55)
            .Text = "PrintDialog"
        End With

        'sistemiamo quello per la finestra Anteprima
        With btnPrintPreviewDialog
            .Size = New Size(125, 25)
            .Location = New Point(25, 85)
            .Text = "PrintPreviewDialog"
        End With

        'quello per l'impostazioni della pagina
        With btnPageSetupDialog
            .Size = New Size(125, 25)
            .Location = New Point(25, 115)
            .Text = "PageSetupDialog"
        End With

        'e infine per il controllo per la rappresentazione permanente dell'anteprima
        With PrintPreviewControl1
            .Size = New Size(300, 400)
            .Location = New Point(170, 25)
            .Document = DocumentoDaStampare
            .Zoom = 0.25
            .UseAntiAlias = True
            .Anchor = CType((((System.Windows.Forms.AnchorStyles.Top _
                               Or System.Windows.Forms.AnchorStyles.Bottom) _
                               Or System.Windows.Forms.AnchorStyles.Left) _
                               Or System.Windows.Forms.AnchorStyles.Right),  _
                               System.Windows.Forms.AnchorStyles)
        End With


        'aggiungiamo i controlli appena impostati alla nostra form
        Me.Controls.Add(btnStampa)
        Me.Controls.Add(btnPrintDialog)
        Me.Controls.Add(btnPrintPreviewDialog)
        Me.Controls.Add(btnPageSetupDialog)
        Me.Controls.Add(PrintPreviewControl1)

    End Sub

    Private Sub btnStampa_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnStampa.Click

        'stampa diretta: si invia alla stampante il nostro documento
        DocumentoDaStampare.Print()

    End Sub

    Private Sub btnPrintDialog_Click(ByVal sender As Object, ByVal e As System.EventArgs) _
    Handles btnPrintDialog.Click

        'se nella finestra di dialogo STAMPA viene premuto il tasto OK allora...
        If PrintDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then

            'il documento da mettere su carta=il nostro documento da stampare
            PrintDialog1.Document = DocumentoDaStampare

            ' e infine lo si stampa
            PrintDialog1.Document.Print()

        End If

    End Sub

    Private Sub btnPrintPreviewDialog_Click(ByVal sender As Object, ByVal e As System.EventArgs) _
    Handles btnPrintPreviewDialog.Click

        'associamo il nostro documento da stampare alla finestra ANTEPRIMA
        PrintPreviewDialog1.Document = DocumentoDaStampare

        'quindi visualizziamo la finestra con il contenuto del nostro documento
        PrintPreviewDialog1.ShowDialog()

    End Sub

    Private Sub btnPageSetupDialog_Click(ByVal sender As Object, ByVal e As System.EventArgs) _
    Handles btnPageSetupDialog.Click

        'creaiamo un nuovo oggetto Impostazioni Pagina
        PageSetupDialog1.PageSettings = New System.Drawing.Printing.PageSettings

        'e un nuovo impostazioni stampante
        PageSetupDialog1.PrinterSettings = New System.Drawing.Printing.PrinterSettings

        'associamo il nostro documento da stampare alla finestra di dialogo IMPOSTA PAGINA
        PageSetupDialog1.Document = DocumentoDaStampare

        'mostriamo la finestra
        PageSetupDialog1.ShowDialog()

    End Sub

    Private Sub DocumentoDaStampare_PrintPage(ByVal sender As Object, ByVal e As  _
    System.Drawing.Printing.PrintPageEventArgs) Handles DocumentoDaStampare.PrintPage

        'istanziamo una nuova penna
        Dim penna As New Pen(Color.Black, 10)

        'creiamo una matrice di 4 punti che raccolgono le coordinate dei vertici del rombo che disegneremo 
        Dim punti() As Point = { _
                New Point(e.MarginBounds.Left + e.MarginBounds.Width \ 2, e.MarginBounds.Top), _
                New Point(e.MarginBounds.Right, e.MarginBounds.Top + e.MarginBounds.Height \ 2), _
                New Point(e.MarginBounds.Left + e.MarginBounds.Width \ 2, e.MarginBounds.Bottom), _
                New Point(e.MarginBounds.Left, e.MarginBounds.Top + e.MarginBounds.Height \ 2)}

        'disegnamo il poligono composto dai 4 vertici appena dichiarati
        e.Graphics.DrawPolygon(penna, punti)

        'rilasciamo le risorse occupate dalla penna
        penna.Dispose()

        'impostiamo la proprietà a false per comunicare al compilatore che la pagina da stampare è una soltanto
        e.HasMorePages = False

    End Sub

End Class
